module CodeFormatter
  class Configuration
    attr_accessor :included_files
    attr_accessor :excluded_files
    attr_accessor :included_dirs
    attr_accessor :excluded_dirs

    attr_reader :source_file

    def initialize
      self.included_files = []
      self.excluded_files = []
      self.included_dirs = []
      self.excluded_dirs = []

      yield self if block_given?
    end

    # @param [String] file
    # @return [Configuration]
    def self.load_from(file)
      return unless file || File.file?(file)

      begin
        config = eval(File.read(file), binding, 'config loading problem')
        config.source_file = file
        return config if config.is_a? Config

        warn "[#{file}] isn't a CodeFormatter::Configuration, but #{config.class}."
      rescue SyntaxError, StandardError => e
        warn "Invalid configuration in [#{file}]: #{e}"
      end
    end

    private

    def source_file=(file)
      return unless file || File.file?(file)
      @source_file = file
    end
  end
end
